-- =============================================
-- Author:		<Author,,Name>
-- Create date: <Create Date,,>
-- Description:	<Description,,>
-- =============================================
CREATE procedure [C6MartPeriodico].[RP_DM_ANAG_PRODOTTI_TERZI_pre_selective]
AS
BEGIN
	SET NOCOUNT ON;
	DECLARE @ID_ELAB INT
	DECLARE @TIPO_ELAB VARCHAR(1)
	SET @ID_ELAB = C6MartPeriodico.GETIDELAB()
	SET @TIPO_ELAB = C6MartPeriodico.GETTIPOELAB()
	-- Log esecuzione
	INSERT INTO LOG_ESECUZIONE
		(Nome, Inizio, Nota)
	VALUES (
		'RP_DM_ANAG_PRODOTTI_TERZI_pre_selective',
		GETDATE(),
		'Elaborazione trimestrale'
	)
	TRUNCATE TABLE C6MartPeriodico.ANAG_PRODOTTI_TERZI
		INSERT INTO [C6MartPeriodico].[ANAG_PRODOTTI_TERZI]
		     ([COD_PRODOTTO]
           ,[COD_PRODOTTO_TERZI]
           ,[NOME_PRODOTTO]
           ,[ALBERO_PRODOTTI]
           ,[COD_ISIN]
           ,[DESCR_PRODOTTO]
           ,[DIV_QUOTAZIONE]
           ,[INTERMEDIARIO]
           ,[DIV_REGOLAMENTO]
           ,[ID_EMITTENTE]
           ,[MERCATO_CONTRATT]
           ,[PAESE]
           ,[RATING]
           ,[ID_ELAB]
           ,[TIPO_ELAB])		   
	SELECT 
		--C6MartPeriodico.VCONTRATTI.chiaveClientePB AS chiaveClientePB,
		C6StagingPeriodico.RP_DettProdottiTerzi.chiaveProdotto AS COD_PRODOTTO,
		ISNULL(Mapping.Temp_oidProd ,C6StagingPeriodico.RP_PatrimonioTerzi.chiaveProdottoTerzi) AS COD_PRODOTTO_TERZI,
		C6StagingPeriodico.RP_PatrimonioTerzi.nomeProdotto AS NOME_PRODOTTO,
		NULL AS ALBERO_PRODOTTI, 
		NULL AS COD_ISIN,
		C6StagingPeriodico.RP_PatrimonioTerzi.tipoprod AS DESCR_PRODOTTO,
		NULL AS DIV_QUOTAZIONE,
		C6StagingPeriodico.RP_DettProdottiTerzi.nomeIntermediario AS INTERMEDIARIO,
		NULL AS DIV_REGOLAMENTO,
		NULL AS ID_EMITTENTE,
		NULL AS MERCATO_CONTRATT,
		NULL AS PAESE,
		NULL AS RATING,
		@ID_ELAB AS ID_ELAB,
	    @TIPO_ELAB AS TIPO_ELAB
	FROM C6StagingPeriodico.RP_DettProdottiTerzi
	INNER JOIN C6StagingPeriodico.RP_PatrimonioTerzi
	ON C6StagingPeriodico.RP_DettProdottiTerzi.chiaveProdottoTerzi = C6StagingPeriodico.RP_PatrimonioTerzi.chiaveProdottoTerzi
	INNER JOIN [C6MartPeriodico].[RP_vContrattiPerGenerazioneReport] VCONTRATTI
	ON C6StagingPeriodico.RP_PatrimonioTerzi.chiaveClientePB = VCONTRATTI.chiaveClientePB
	LEFT JOIN C6StagingPeriodico.RP_MappingTerzi Mapping
	ON C6StagingPeriodico.RP_DettProdottiTerzi.chiaveProdottoTerzi = Mapping.chiaveProdottoTerzi
	-- Log esecuzione
	UPDATE
		LOG_ESECUZIONE
	SET
		Fine = GETDATE(),
		Tipo = 'INSERT',
		Righe = @@ROWCOUNT
	WHERE
		Nome = 'RP_DM_ANAG_PRODOTTI_TERZI_pre_selective' AND
		Inizio = (
			SELECT
				MAX(Inizio)
			FROM
				LOG_ESECUZIONE
			WHERE
				Nome = 'RP_DM_ANAG_PRODOTTI_TERZI_pre_selective'
		)
END